#include <cpctelera.h>
#include <stdio.h>
#include <string.h>
#include "main.h"
#include "funciones.h"
#include "fonts.h"
#include "consola.h"
#include "graficos/Sprites_rgas.h"
#include "musica/m_fasesA.h"
#include "musica/m_fasesB.h"
#include "musica/m_intro.h"


void colisionesFase3(){
	if (objetos[0].temp == 0 && (hayColision(&objetos[0], &ParedA) || hayColision(&objetos[0], &ParedB)) )
			muerteObjeto(&objetos[0]);
}

void escenario(){
	u8 i;
//ESCENARIO NIVEL 2
	if (nivel == 2) {
		//Luna
		//Escribir directamente en memoria la circunferencia para no crear sprite con casi todo a 0
	*((u8*)0xC414) = 0x3F;*((u8*)0xC415) = 0xFF;*((u8*)0xC416) = 0xC0;*((u8*)0xC46A) = 0x03;*((u8*)0xC46B) = 0xF0;*((u8*)0xC4BD) = 0x01;
	*((u8*)0xC4BE) = 0xE0;*((u8*)0xC50F) = 0x01;*((u8*)0xC510) = 0xE0;*((u8*)0xC561) = 0x1C;*((u8*)0xC5B2) = 0x0C;*((u8*)0xC603) = 0x30;
	*((u8*)0xC653) = 0x06;*((u8*)0xC6A3) = 0x03;*((u8*)0xC6F3) = 0x0E;*((u8*)0xCC15) = 0x0F;*((u8*)0xCC16) = 0xFF;*((u8*)0xCC17) = 0xC0;
	*((u8*)0xCC6B) = 0x3F;*((u8*)0xCCBE) = 0x78;*((u8*)0xCD10) = 0x78;*((u8*)0xCD61) = 0x07;*((u8*)0xCDB2) = 0x06;*((u8*)0xCE03) = 0x30;
	*((u8*)0xCE53) = 0x06;*((u8*)0xCEA3) = 0x03;*((u8*)0xCEF3) = 0x0C;*((u8*)0xD416) = 0x01;*((u8*)0xD417) = 0xFF;*((u8*)0xD418) = 0x80;
	*((u8*)0xD46B) = 0x07;*((u8*)0xD46C) = 0xE0;*((u8*)0xD4BE) = 0x1F;*((u8*)0xD510) = 0x1C;*((u8*)0xD561) = 0x03;*((u8*)0xD562) = 0x80;
	*((u8*)0xD5B2) = 0x03;*((u8*)0xD603) = 0x18;*((u8*)0xD653) = 0x06;*((u8*)0xD6A3) = 0x03;*((u8*)0xD6F3) = 0x0C;*((u8*)0xDC17) = 0x07;
	*((u8*)0xDC18) = 0xFE;*((u8*)0xDC6C) = 0xFC;*((u8*)0xDCBE) = 0x03;*((u8*)0xDCBF) = 0xC0;*((u8*)0xDD10) = 0x0F;*((u8*)0xDD61) = 0x01;
	*((u8*)0xDD62) = 0xC0;*((u8*)0xDDB2) = 0x03;*((u8*)0xDDB3) = 0x80;*((u8*)0xDE03) = 0x18;*((u8*)0xDE53) = 0x07;*((u8*)0xDEA3) = 0x03;
	*((u8*)0xDEF3) = 0x18;*((u8*)0xE418) = 0x1F;*((u8*)0xE419) = 0xF0;*((u8*)0xE46C) = 0x0F;*((u8*)0xE46D) = 0x80;*((u8*)0xE4BF) = 0xF0;
	*((u8*)0xE510) = 0x03;*((u8*)0xE511) = 0x80;*((u8*)0xE562) = 0xE0;*((u8*)0xE5B2) = 0x01;*((u8*)0xE5B3) = 0xC0;*((u8*)0xE603) = 0x0C;
	*((u8*)0xE653) = 0x03;*((u8*)0xE6A3) = 0x07;*((u8*)0xE6F3) = 0x18;*((u8*)0xEC19) = 0xFF;*((u8*)0xEC6C) = 0x01;*((u8*)0xEC6D) = 0xF0;
	*((u8*)0xECBF) = 0x3C;*((u8*)0xED11) = 0xC0;*((u8*)0xED62) = 0x70;*((u8*)0xEDB3) = 0xC0;*((u8*)0xEE03) = 0x0C;*((u8*)0xEE53) = 0x03;
	*((u8*)0xEEA3) = 0x06;*((u8*)0xEEF3) = 0x30;*((u8*)0xF3C0) = 0x1F;*((u8*)0xF3C1) = 0xFF;*((u8*)0xF3C2) = 0xFE;*((u8*)0xF419) = 0x07;
	*((u8*)0xF41A) = 0xF8;*((u8*)0xF46D) = 0x7C;*((u8*)0xF4BF) = 0x0E;*((u8*)0xF511) = 0x70;*((u8*)0xF562) = 0x38;*((u8*)0xF5B3) = 0x60;
	*((u8*)0xF603) = 0x0C;*((u8*)0xF653) = 0x03;*((u8*)0xF6A3) = 0x06;*((u8*)0xFBC0) = 0xF8;*((u8*)0xFBC2) = 0x07;*((u8*)0xFBC3) = 0xFF;
	*((u8*)0xFBC4) = 0xFF;*((u8*)0xFBC5) = 0x80;*((u8*)0xFC1A) = 0x7F;*((u8*)0xFC1B) = 0x80;*((u8*)0xFC6D) = 0x0F;*((u8*)0xFC6E) = 0x80;
	*((u8*)0xFCBF) = 0x03;*((u8*)0xFCC0) = 0x80;*((u8*)0xFD11) = 0x38;*((u8*)0xFD62) = 0x1C;*((u8*)0xFDB3) = 0x60;*((u8*)0xFE03) = 0x06;
	*((u8*)0xFE53) = 0x03;*((u8*)0xFEA3) = 0x06;
	}

//ESCENARIO NIVEL 3
	if (nivel == 3){
		//Paredes vista vertical	
		i = AREA_JUEGO_INFERIOR - LIMITE_NIVEL3 - 1;
		do {
			paredIzq[(2*i)] = paredIzq[(2*(i-1))];
			paredIzq[(2*i)+1] = paredIzq[(2*(i-1))+1];

			paredDer[(2*i)] = paredDer[(2*(i-1))];
			paredDer[(2*i)+1] = paredDer[(2*(i-1))+1];
			--i;
		} while (i);

		//Paredes vista horizontal
		paredArr1[39]=paredArr2[0]; //Corte entre bloques
		paredArr1[79]=paredArr2[40]; 
		paredAba1[39]=paredAba2[0]; //Corte entre bloques
		paredAba1[79]=paredAba2[40]; 

		
		for (i = 0; i<(ANCHO_PANTALLA/2)-1; i++){
			paredArr1[i]=paredArr1[i+1];
			paredArr1[(ANCHO_PANTALLA/2)+i]=paredArr1[(ANCHO_PANTALLA/2)+i+1];
			paredArr2[i]=paredArr2[i+1];
			paredArr2[(ANCHO_PANTALLA/2)+i]=paredArr2[(ANCHO_PANTALLA/2)+i+1];

			paredAba1[i]=paredAba1[i+1];
			paredAba1[(ANCHO_PANTALLA/2)+i]=paredAba1[(ANCHO_PANTALLA/2)+i+1];
			paredAba2[i]=paredAba2[i+1];
			paredAba2[(ANCHO_PANTALLA/2)+i]=paredAba2[(ANCHO_PANTALLA/2)+i+1];
		}
		
		ParedA.offset = ParedB.offset = 2;
		// Paredes vista vertical (usa ->offset)
		if (timeline < 1600 && timeline > 900) { // Estrechar paredes
			if (paredIzq[1] == 0xFF) 
				ParedA.offset = 2;
			else	
				ParedA.offset = 1;

			if (paredDer[0] == 0xFF) 	
				ParedB.offset = 2;
			else	
				ParedB.offset = 0;
		} else if (timeline < 600 && timeline > 450) { // Ensanchar Paredes porque la otra vista se ha estrechado 
			if (paredIzq[0] == 0x00) 
				ParedA.offset = 2;
			else	
				ParedA.offset = 0;
			
			if (paredDer[1] == 0x00) 	
				ParedB.offset = 2;
			else	
				ParedB.offset = 1;
		} else {
			//Cada 45 Bytes cambiar una de las dos paredes 0=IZQUIERDA; 1=DERECHA; 2=NADA
			if (timeline % 45 == 0){
								
				if (paredIzq[1] == 0xFF) // ParedA sólo puede ir a la izquierda para dejar hueco
					ParedA.offset = 0;
				else if (paredDer[0] == 0xFF) // ParedB está a la izquierda del todo y el único movimiento posible es ir a la derecha
					ParedB.offset = 1;
				else if (paredIzq[0] == 0xFF && paredDer[1] == 0xFF) { //No queda más espacio en el centro, una de las paredes debe volver
					if (cpct_rand()%2)
						ParedA.offset = 0;
					else
						ParedB.offset = 1;
				} else { 
					if (cpct_rand()%2)
						if (paredIzq[0] == 0x00) //Pared al limite exterior, sólo puede ir al otro lado
							ParedA.offset = 1;
						else 		
							ParedA.offset = cpct_rand()%2;	
					else
						if (paredDer[1] == 0xFF)
							ParedB.offset = 0;
						else
							ParedB.offset = cpct_rand()%2;	
					}
				}
			}

		switch (ParedA.offset) {
			case 0: if (paredIzq[1] == 0xFF) {
				paredIzq[0] = 0xFF;
				paredIzq[1] = 0x00;
				} else { //paredIzq[0] == 0xFF
				paredIzq[0] = 0x00;
				}
				
				break;
			case 1: if (paredIzq[0] == 0x00) {
				paredIzq[0] = 0xFF;
				} else { //paredIzq[0] == 0xFF
				paredIzq[1] = 0xFF;
				}
				break;
			}
		
		switch (ParedB.offset) {
			case 0: if (paredDer[1] == 0x00) {
				paredDer[1] = 0xFF;
				} else { //paredDer[0] == 0x00
				paredDer[0] = 0xFF;
				}
				break;
			case 1: if (paredDer[0] == 0x00) {
				paredDer[1] = 0x00;
				} else { //paredDer[0] == 0xFF
				paredDer[0] = 0x00;
				}
				break;
			}			

		//Paredes vista horizontal (usa ->offset_otro)
		if ((timeline < 2000 && timeline > 1800) || (timeline < 500 && timeline > 100)) { // Estrechar
			if (paredArr2[79] == 0xFF) 
				ParedA.offset_otro = 2;
			else	
				ParedA.offset_otro = 1;

			if (paredAba2[39] == 0xFF) 	
				ParedB.offset_otro = 2;
			else	
				ParedB.offset_otro = 0;
		} else if (timeline < 1700 && timeline > 1550){ //Ensanchar porque otra vista está estrechada
			if (paredArr2[79] == 0x00) 
				ParedA.offset_otro = 2;
			else	
				ParedA.offset_otro = 0;

			if (paredAba2[39] == 0x00) 	
				ParedB.offset_otro = 2;
			else	
				ParedB.offset_otro = 1;
		} else {
			//Cada 10 Bytes cambiar una de las dos paredes 0=ARRIBA; 1=ABAJO; 2=NADA
			if (timeline % 10 == 0){
				
				if (paredArr2[79] == 0xFF) // ParedA está abajo y el único movimiento posible es subirla para dejar hueco
					ParedA.offset_otro = 0;
				else if (paredAba2[39] == 0xFF) // ParedB está arriba y el único movimiento posible es bajarla para dejar hueco
					ParedB.offset_otro = 1;
				else { //ParedA está arriba y ParedB está abajo, puede moverse cualquiera de las 2
					if (cpct_rand()%2)		
						ParedA.offset_otro = 1;	
					else
						ParedB.offset_otro = 0;	
				}
			}
		}
		
		switch (ParedA.offset_otro) {
			case 0:paredArr2[39]=0xFF; 
				paredArr2[79]=0x00; 
				break;
			case 1:paredArr2[39]=0xFF; 
				paredArr2[79]=0xFF; 
				break;
		}

		switch (ParedB.offset_otro) {
			case 0:paredAba2[39]=0xFF; 
				paredAba2[79]=0xFF; 
				break;
			case 1:paredAba2[39]=0x00; 
				paredAba2[79]=0xFF; 
				break;
		}

		cpct_waitVSYNC();
		cpct_setBlendMode(CPCT_BLEND_LDI);
		if (vista == VERTICAL){
			cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, 35, 91),  91, 2, paredIzq);
			//cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, ParedA.x, ParedA.y),  ParedA.alto, ParedA.ancho, paredIzq);
			cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, 41, 91),  91, 2, paredDer);
			//cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, ParedB.x, ParedB.y),  ParedB.alto, ParedB.ancho, paredDer);
		} else { 
		//No permite más de 64 bytes de ancho, se ha de hacer en 2 partes
			cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, 0, 101),  2, 40, paredArr1);
			//cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, ParedA.x, ParedA.y),  ParedA.alto, ParedA.ancho, paredArr1);
			cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, 40, 101),  2, 40, paredArr2);
			//cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, ParedA.x+40, ParedA.y),  ParedA.alto, ParedA.ancho, paredArr2);
			cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, 0, 119),  2, 40, paredAba1);
			//cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, ParedB.x, ParedB.y),  ParedB.alto, ParedB.ancho, paredAba1);
			cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, 40, 119),  2, 40, paredAba2);
			//cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, ParedB.x+40, ParedB.y),  ParedB.alto, ParedB.ancho, paredAba2);
		}
		cpct_setBlendMode(CPCT_BLEND_OR);
	}

//ESCENARIO NIVEL 4
	if (nivel == 4){	
		if (vista == VERTICAL) {
			//Tierra
			cpct_drawSpriteBlended(cpct_getScreenPtr(CPCT_VMEM_START, 75, 0), 20, 5,G_Tierra1V);

			//Luna 120*60
			cpct_drawSpriteBlended(cpct_getScreenPtr(CPCT_VMEM_START, 0, 102),80,20,G_Luna_Grande);
		} else {
			//Tierra
			cpct_drawSpriteBlended(cpct_getScreenPtr(CPCT_VMEM_START, 75, 162), 20, 5,G_Tierra1V);			
		}
	}

//ESCENARIO NIVEL 5
			
//ESCENARIO NIVEL 6 - NAVE NODRIZA 48B x 41px
	if (nivel == 6 && timeline > 0){
		if (timeline % 16 == 0) {
			cpct_drawSolidBox (cpct_getScreenPtr(CPCT_VMEM_START, (timeline / 16), 0),  0, 48, 41);
		}
		
		cpct_drawSpriteBlended(cpct_getScreenPtr(CPCT_VMEM_START, (timeline - 1) / 16, 0), 41, 48, G_Nodriza);
	}
}

void initObjetos3(){
	u8 i;

	vista = VERTICAL;
	//Camino Inicial
	for (i=0; i<AREA_JUEGO_INFERIOR - AREA_JUEGO_SUPERIOR_INI; i++){
		paredIzq[(2*i)]= 0x00;
		paredIzq[(2*i)+1] = 0x00;
		paredDer[(2*i)] = 0x00;
		paredDer[(2*i)+1]= 0x00;
	}
	//Pintar Camino Inicial
	for (i=0; i<ANCHO_PANTALLA/2; i++){
		paredArr1[i] = 0xFF;
		paredArr2[i] = 0xFF;
		paredArr1[(ANCHO_PANTALLA/2)+i] = 0x00;
		paredArr2[(ANCHO_PANTALLA/2)+i] = 0x00;

		paredAba1[i] = 0x00;
		paredAba2[i] = 0x00;
		paredAba1[(ANCHO_PANTALLA/2)+i] = 0xFF;
		paredAba2[(ANCHO_PANTALLA/2)+i] = 0xFF;
	}

	initParedVertical();

	posicionInicialNave();
	//Cojo nave girada porque tiene pixel libre a ambos lados y así no colisionará contra paredes cuando lleguen a su límite
	objetos[0].sprite = &G_NaveEscuelaV2[0]; 
	objetos[0].ancho = 6;

}


void ansible() {
	u8 i;
	u8 *dummy;
	i = 6;
	while (i) {
		for (dummy = (u8*) 0xC000; dummy < (u8*) 0xFFFF; dummy++) {
			*((u8*) dummy) = ~((u8)(*dummy));
		}
		--i;
		cpct_akp_SFXPlay (1, 15, 9*i, 0, 0, AY_CHANNEL_B);
	}
}

void pantallaFinal(){

	//Puntuación extra por hacerlo en menos de 9 minutos
	if (speedrun_digitos[3] == 0 && speedrun_digitos[2] < 9) {
		puntuacion += 50;
		*(u8*)&txtTiempoTotal[27] = 51;
	}

	//Explosión nodriza
   	vista_pulsada = 5; //Reutilización de variable para uso temporal
   	while (vista_pulsada) {
	   	objetos[1].temp = 10; 
	   	objetos[1].x = 10 + (timeline / 16) + cpct_rand() % 38;	
	   	objetos[1].y = 15 + cpct_rand() % 10;
	   	objetos[1].sprite = G_Asteroide_m;
	   	objetos[1].ancho = 7;
	   	objetos[1].alto = 32;
	   	while (objetos[1].temp < 128) {
	   		cpct_waitVSYNC();
			explosion(&objetos[1]);
	   	}

		cpct_drawSpriteBlended(cpct_getScreenPtr(CPCT_VMEM_START, timeline / 16, 0), 41, 48, G_Nodriza);
		vista_pulsada--;
	}
	//Mostrar Pantalla final
	cpct_akp_stop();
	borrarPantalla();

	//Nave 176*57
	cpct_drawSpriteBlended(cpct_getScreenPtr(CPCT_VMEM_START, 10, 100),57,22,G_NaveIntro);

	//Planeta destruido
	cpct_drawSpriteBlended(cpct_getScreenPtr(CPCT_VMEM_START, 34, 75),41,11,G_Planeta_final);

	//Texto final
	txtSupFinal();
	
	pausaTecladoLibre();
	while (!tecladoPulsado())
		;

	vidas = 0;
}

void calcularTiempoTotal(){
	u32 timestop;

	//Parar Speedrun
	timestop = speedrun / 300; //Cada 300 ciclos es un segundo
   	speedrun_digitos[0] = 0;
	speedrun_digitos[1] = 0;
	speedrun_digitos[2] = 0;
	speedrun_digitos[3] = 0;

	while (timestop--) {
		speedrun_digitos[0]++;
		if (speedrun_digitos[0] > 9){
			speedrun_digitos[1]++;
			speedrun_digitos[0]=0;
			if (speedrun_digitos[1] > 5){
				speedrun_digitos[2]++;
				speedrun_digitos[1]=0;
				if (speedrun_digitos[2] > 9) {
					speedrun_digitos[3]++;
					speedrun_digitos[2]=0;
				}
			}
		}
	}
}

void tutorial(){
	u8 i;

	borrarPantalla();

	vista = VERTICAL;
	laser.x = laser.y = 0;
	laser.z = TIMEOUT_DISPARO;
	laser.temp = 0;
	total_elementos = 4;

	// Posición Inicial Nave
	posicionInicialNave();
	objetos[0].temp = 0; 

	//Posición asteroides
	objetos[1].x = 33;  objetos[1].y = 70; 	objetos[1].z = 95;
	objetos[2].x = 39; 	objetos[2].y = 104; objetos[2].z = 65;
	objetos[3].x = 36;	objetos[3].y = 110; objetos[3].z = 142;

	for (i=1;i<total_elementos;i++){
		objetos[i].sprite = &G_Asteroide_m[0]; objetos[i].sprite_otro = &G_Asteroide_m[0];
		objetos[i].alto = objetos[i].alto_otro = 16;
		objetos[i].ancho = objetos[i].ancho_otro = 4;
		//objetos[i].offset = objetos[i].offset_otro = 0;
		//objetos[i].temp = 0;
		objetos[i].tipo = 1;
	}
	//PASO 1
	gestionEnemigos();
	pintarNave();
	
	initTxtInferior();
	txtInfMarcador();
	txtSupTutorial1();
	

	//gestionEnemigos();
	for (i=0; i<4;i++) {moverNave(0x0A); }
	for (i=0; i<21; i++) moverNave(0x02);

	laser.temp = 1;
	for (i=0; i<41; i++){Laser(); colisiones(); gestionEnemigos();}
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 29);	
	txtInfContinuar();

	//PASO 2
	txtSupTutorial2();
	for (i=0; i<21; i++){
	 	moverNave(0x01);
	 	gestionEnemigos();
	}
	for (i=0; i<4;i++) {
		moverNave(0x04);
		gestionEnemigos();
	}
	laser.temp = 1;
	for (i=0; i<41; i++){Laser(); colisiones(); gestionEnemigos();}
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 29);	
	txtInfContinuar();

	//PASO 3
	factor_vista = (float) (AREA_JUEGO_INFERIOR - AREA_JUEGO_SUPERIOR_INI) / ANCHO_PANTALLA; 

	txtSupTutorial3();
	for (i=0; i<25; i++) {
		moverNave(0x02);
		gestionEnemigos();
	} 
	cambiarVista();
	pintarNave(); gestionEnemigos();
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 29);	
	txtInfContinuar();

	//PASO 4
	txtSupTutorial4();
	for (i=0; i<14; i++) { moverNave(0x09);}
	for (i=0; i<6; i++) {moverNave(0x01);}
	laser.temp = 1;
	for (i=0; i<41; i++){Laser(); colisiones(); gestionEnemigos(); moverNave(0x02);}
	//for (i=0; i<5; i++) {moverNave(0x02);}
	laser.temp = 1;
	for (i=0; i<41; i++){Laser(); colisiones(); gestionEnemigos(); }
	f_c = cpct_getScreenPtr(CPCT_VMEM_START, 2, 29);	
	txtInfContinuar();

	musica = 0;
}

void juego(){
	vidas = 3;
	puntuacion = 0;
	vista_pulsada = 0;
	speedrun = 0;
	nivel = 1; 
	timeline = 65535; 
// Por defecto las globales ya se inicializan a 0, ahorro código
	//  contador_musica = 0;
	//	estrategias[0] = estrategias[1] = estrategias[2] = estrategias[3] = 0;
	while (vidas > 0 && nivel < 7) {
		explosion_FX = 0;
		if (nivel > 3) // Redimensionar área de juego y recalcular factor de vista
			AREA_JUEGO_SUPERIOR_VAR = 0;

		factor_vista = (float) (AREA_JUEGO_INFERIOR - AREA_JUEGO_SUPERIOR_VAR) / ANCHO_PANTALLA;  //Recalcular al cambiar area de juego

		pausaTecladoLibre();
		borrarPantalla();

//Música
		if (nivel < 4 )
			cpct_akp_musicInit(m_fasesA);
		else if (nivel < 6)
			cpct_akp_musicInit(m_fasesB);
		else
			cpct_akp_musicInit(m_intro);
		

//Inicialización de cada nivel
		if (nivel == 1) {
			txtSupFase1();
			total_elementos = 6;
			enemigos = 5;
		}
		if (nivel == 2) {
			txtSupFase2();
			total_elementos = 2;
			enemigos = 8;
		}
		if (nivel == 3) {
			timeline = 1921; 
			txtSupFase3();
			total_elementos = 1;
			enemigos = 1;
		}
		if (nivel == 4) {
			txtSupFase4();
			borrarPantalla();
			pausaTecladoLibre();
			while (!tecladoPulsado) 
				;
			total_elementos = 4;
			enemigos = 9;
		}
		if (nivel == 5) {
			total_elementos = 7;
			enemigos = 12;
		}
		if (nivel == 6) {
			total_elementos = 4;
			enemigos = 20; // Energía (toques) de la nave nodriza
			timeline = 512;//32 * 16. x inicial = 80 - 48 = 32, por tener un ancho la nave nodriza de 48B. Cada 16 iteraciones se moverá x--
			pintarEnergiaNodriza();
		}

		if (nivel == 3) {
			initObjetos3();
			backgroundFase3();
			cpct_setBlendMode(CPCT_BLEND_LDI);
			cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, 35, 91),  91, 2, ParedA.sprite);
			//cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, ParedA.x, ParedA.y),  ParedA.alto, ParedA.ancho, ParedA.sprite);
			cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, 41, 91),  91, 2, ParedB.sprite);
			//cpct_drawSpriteBlended (cpct_getScreenPtr(CPCT_VMEM_START, ParedB.x, ParedB.y),  ParedB.alto, ParedB.ancho, ParedB.sprite);
			cpct_setBlendMode(CPCT_BLEND_OR);
		} else
			initObjetos();

		if (nivel == 4){
			esAsteroide(&objetos[1]);
			esAsteroide(&objetos[2]);
		}
		if (nivel == 5){
			esAsteroide(&objetos[1]);
			esAsteroide(&objetos[2]);
			esAsteroide(&objetos[3]);
			esAsteroide(&objetos[4]);
		}

		pintarNave();
//Marcador		
		initTxtInferior(); //Sólo es necesario llamarlo una vez, así no se ralentiza al actualizar marcador
		txtInfMarcador();
//BUCLE hasta morir o queden enemigos		
		while (vidas > 0 && enemigos > 0) {
//Gestión de Enemigos			
			if (nivel != 3)
				gestionEnemigos();
//Teclado
		   	accionesTeclado();
//Láser nave principal
			if (nivel != 3)
				Laser();
//Disparos de enemigos			
			if (nivel == 2 || nivel == 4 || nivel == 5)
				disparosEnemigos();
//Escenario
			escenario();
			pintarNave(); //Necesario por si ha sido borrada por alguna explosión
//Invulnerable
			if (objetos[0].temp > 127) 
				invulnerabilidad();
//Colisiones			
			if (nivel == 3)
				colisionesFase3();
			else
				colisiones();

			--timeline;

//Pintado Extra
			if (nivel == 3) {
				if (timeline % 128 == 0)
					pintarRestanteNivel3();
				
				if (timeline == 0) {
					enemigos = 0;  //Marcar fin de nivel
					puntuacion += 30;
				}
			}

			if (nivel == 6 && !timeline){//Fin del tiempo, game over
				muerteObjeto(&objetos[0]);
				vidas = 0;
			}
	   	}
//Fin Nivel
	 	if (vidas) {
	   		if (nivel == 3)
	   			ansible();

		   	if (nivel < 6)
		   		nivel++;
		   	else {
//Pantalla Final del juego
			   	puntuacion += 60;
			   	puntuacion += (vidas * 10); //Vidas restantes puntúan
			   	vidas = 0;
			   	calcularTiempoTotal();
			   	pantallaFinal();
		   }
		} 
	} 
	// Game Over, salir

	if (cheat) //Invalidar puntuación si está el modo cheat activado
		puntuacion = 0;
	
	actualizarMarcador(); //actualizar puntuación
	calcularTiempoTotal();
	AREA_JUEGO_SUPERIOR_VAR = AREA_JUEGO_SUPERIOR_INI; //Restablecer Area de Juego Superior
	cpct_akp_stop();
}