void pausaTecladoLibre();
u8 tecladoPulsado();
//void escribir_u(u32 valor);
//void escribir_i8(i8 valor);
u8 maximo (u8 punto1, u8 punto2);
u8 minimo (u8 punto1, u8 punto2);
u8 recortar (u8 valor, u8 tipo, u8 limite);
//Acciones Teclado
u8 pressedUp();
u8 pressedDown();
u8 pressedLeft();
u8 pressedRight();
u8 pressedFire();
u8 pressedChangeView();
void accionesTeclado();
//Funciones recurrentes
u8 RandomX();
u8 RandomY(u8 clip);

//Colisiones
u8 hayColision(TObjeto *o1, TObjeto *o2);
u8 hayColisionDisparo(TObjeto *o, TDisparo *d);
void colisiones();
//Muertes
void muerteObjeto(TObjeto *o);
//Aprendizaje
void estrategiaInsector(TObjeto *o);
void aprendizajeInsector(TObjeto *o, i8 signo);

//Pintar
void backgroundFase3();
void borrarPantalla() __z88dk_callee;
void borrarAreaJuego();
void invulnerabilidad();
void pintarNave();
void cambiarVista();
void posicionInicialNave();
void esAsteroide(TObjeto *o);
void esInsector(TObjeto *o);
void initObjetos();
void initParedVertical();
void initParedHorizontal();

//Movimientos
void oleadas();
void gestionEnemigos();
void Laser();
void moverNave(u8 movimiento);
void explosion(TObjeto *o); 
void disparosEnemigos();

cpct_keyID getKey();
//void cpct_drawSpriteBlended_NAND (u8* memory, u8 height, u8 width, const u8* sprite) __z88dk_callee __naked;
void cpct_drawSpriteBlended_NAND (u8* memory, u8 height, u8 width, const u8* sprite) __z88dk_callee;
